<template lang="pug">
.collapse.card
	.collapse-trigger.card-header
		p.card-header-title( @click='expanded = !expanded' ) {{data.title}}
		.card-header-icon( :class='{ "is-rotated": expanded }' @click='expanded = !expanded' )
			span.icon
				i.fa-solid.fa-angle-down
		.card-header-icon
			b-button( type="danger" size="small" @click='emit("remove")' )
				span.icon( :class='{ "is-rotated": expanded }' )
					i.fa-solid.fa-trash-can
	.collapse-body( :class='{ "is-expanded": expanded }' )
		.collapse-content.card-content
			b-field( :label='$t("form.question")' )
				b-input( v-model='data.title' @update:modelValue='handleTitleUpdate' )
			b-field( :label='$t("form.content")' )
				b-content( v-model='data.content' @update:modelValue='handleContentUpdate' )
</template>

<script setup>
import BField from "@/components/form/Field.vue"
import BInput from "@/components/form/Input.vue"
import BContent from "@/components/form/Content.vue";

import { computed, onMounted, ref, watch } from "vue"

const props = defineProps({
	modelValue: {
		type: Object,
		default: () => ({})
	}
})
const emit = defineEmits([ "update:modelValue", "remove" ])

const data = computed({
	get: () => ({
		title: props.modelValue?.title,
		content: { data: props.modelValue?.content }
	}),
	set: val => emit("update:modelValue", val)
})

const expanded = ref(false)

const handleTitleUpdate = val => {
	data.value = {
		title: val,
		content: data.value?.content?.data
	}
}

const handleContentUpdate = val => {
	data.value = {
		title: data.value?.title,
		content: val?.data
	}
}
</script>

<style lang="scss" scoped>
.collapse {
	&-trigger {
		cursor: pointer;
		user-select: none;
	}
	&-body {
		max-height: 0;
		overflow: hidden;
		transition: all .2s ease-in-out;
		&.is-expanded {
			max-height: 200rem;
		}
	}

	.card-header-icon {
		transition: all .2s ease-in-out;
		&.is-rotated {
			transform: rotate(180deg);
		}
	}
}
</style>